#include "config"

void Config::setbackend (string str) {
    vector<string> parts;
    int pos;
    while ( (pos = str.find_first_of(":")) > 0) {
	if (pos > 0)
	    parts.push_back (str.substr(0, pos));
	str = str.substr(pos + 1);
    }
    if (str.length() > 0)
	parts.push_back (str);
    if (parts.size() < 2 || parts.size() > 3)
	throw((Error) "Bad back end specifier in '-b" + str +
	      "', expected: SERVER:PORT or SERVER:PORT:MAXCONNECTIONS");
    if (parts.size() == 2) {
	BackendDef bd (parts[0], parts[1]);
	blist.push_back (bd);
    } else {
	BackendDef bd (parts[0], parts[1], parts[2]);
	blist.push_back (bd);
    }
}
