#include "config"

void Config::setdispatchmode (string s) {
    if (s == "r" || s == "round-robin")
	dmode.mode (Dispatchmode::m_roundrobin);
    else if (s == "l" || s == "least-connections")
	dmode.mode (Dispatchmode::m_leastconn);
    else if (s == "f" || s == "first-available")
	dmode.mode (Dispatchmode::m_firstactive);
    else if (s.substr(0, 2) == "e:") {
	dmode.mode (Dispatchmode::m_external);
	external_algorithm = s.substr (2);
    } else if (s.substr (0, 9) == "external:") {
	dmode.mode (Dispatchmode::m_external);
	external_algorithm = s.substr(9);
    }
    else
	throw ((Error) "Bad dispatch mode -d" + s);

    if (dmode.mode() == Dispatchmode::m_external &&
	external_algorithm.size() < 1)
	throw ((Error) "External algorithm handler missing");
}
