#include "external"

int External::target() {
    // Prepare command to run
    ostringstream o;
    o << config.externalalgorithm() << ' ' << balancer.nbackends();
    for (unsigned i = 0; i < balancer.nbackends(); i++)
	o << ' ' << balancer.backend(i).description() << ' '
	  << balancer.backend(i).availablestr()
	  << ' ' << balancer.backend(i).connections();
    msg ("External algorithm: invoking '" + o.str() + "'\n");

    FILE *f;
    if (! (f = popen (o.str().c_str(), "r")) )
	throw ((Error) "Cannot start '" + o.str() + "': " + strerror(errno));
    int i;
    if (fscanf (f, "%d", &i) < 1)
	throw ((Error) "External algorithm '" + o.str() + "' did not reply "
	       "with a number");

    ostringstream n;
    n << i;
    msg ("External algorithm says: " + n.str() + "\n");

    if (i < 0 || i >= (int)balancer.nbackends())
	throw ((Error) "External algorithm '" + o.str() + "': answer " +
	       n.str() + " out of bounds");
    if (pclose (f))
	throw ((Error) "External algorithm '" + o.str() + "' terminated "
	       "with error");

    return (i);
}
