#include "httpbuffer"

static bool ishex (char ch) {
    return (ch >= '0' && ch <= '9' ||
	    ch >= 'a' && ch <= 'f' ||
	    ch >= 'A' && ch <= 'F');
}

Httpbuffer::Bodystatus Httpbuffer::bodyreceived() {
    // No headers? Not done.
    if (!headersdone())
	return (b_is_not_received);

    // If we have a content length, the body must match it.
    string str = headerval("Content-Length");
    unsigned clen;
    if (sscanf (str.c_str(), "%d", &clen) > 0) {
	if (size() - bodystart >= clen)
	    return (b_is_received);
	else
	    return (b_is_not_received);
    }

    // If we have chunks, then the last chunk must be zero.
    str = headerval ("Transfer-Encoding");
    if (!strcasecmp (str.c_str(), "chunked")) {
	for (unsigned i = bodystart; i < size(); /* increment below */ ) {
	    unsigned chunk;
	    if (sscanf (data() + i, "%x", &chunk) < 1)
		return (b_is_not_received);
	    if (!chunk)
		return (b_is_received);
	    while (ishex(charat(i)) && i < size())
		i++;
	    if (charat(i) == '\r')
		i++;
	    if (charat(i) == '\n')
		i++;
	    i += chunk;
	}
    }

    // No content length, no chunks... We just dunno.
    return (b_unknown);
}
	
