#include "httpdispatcher"

void HttpDispatcher::dispatch() {
    unsigned stickytarget;

    // Get the client's request. May need for cookie inspection.
    if (!getclientrequest())
	throw ((Error) "Didn't receive a valid client request.\n");

    // Dispatch as a normal backend if sticky HTTP is off, or if the
    // sticky target is badly specified.
    if (!config.stickyhttp() ||
	sscanf (clientrequest.cookievalue ("XRTarget").c_str(),
		"%d", &stickytarget) < 1 ||
	stickytarget >= balancer.nbackends()) {
	issticky(false);
	TcpDispatcher::dispatch();
    } else {
	// Got a sticky target. Try to connect. If that fails, fallback
	// to non-sticky dispatching.
	targetbackend(stickytarget);
	Backend tb = balancer.backend(stickytarget);
	msg ("Sticky HTTP request for " + tb.description() + "\n");
	if (! tb.connect()) {
	    lock();
	    balancer.backend(stickytarget).live(false);
	    unlock();
	    msg ("Failed to connect to back end " + tb.description() +
		 ", trying to dispatch to other\n");
	    issticky(false);
	    TcpDispatcher::dispatch();
	} else {
	    backendfd(tb.sock());
	    issticky(true);
	}
    }
}

