#include "stopthread"

void Stopthread::execute() {
    static int stopping;
    static int last_connections;
    int loc_stopping;

    if ( (loc_stopping = stopping) ) {
	msg ("XR is waiting to shut down.\n");
	return;
    }

    lock();
    stopping++;
    unlock();
    msg ("XR will shut down.\n");

    while (1) {
	if (balancer.connections()) {
	    ostringstream o;
	    o << balancer.connections();
	    msg ("There are still " + o.str() + " connections, "
		 "XR will stop when they do.\n");
	    sleep (1);
	    continue;
	}
	msg ("No active connections, terminating XR.\n");
	exit (0);
    }
}
