#include "tcpdispatcher"

void TcpDispatcher::dispatch() {
    Backend tb;
    bool connected = false;

    while (!connected) {
	target_backend = algorithm->target();
	tb = balancer.backend(target_backend);
	if (!tb.connect()) {
	    lock();
	    balancer.backend(target_backend).live(false);
	    unlock();
	    msg ("Failed to connect to back end " + tb.description() +
		 ", trying to dispatch to other\n");
	} else {
	    connected = true;
	    backendfd(tb.sock());

	    ostringstream o;
	    o << target_backend;
	    msg ("Dispatching client to back end " + o.str() + " " +
		 tb.description() + "\n");
	    
	    break;
	}
    }
}
