#include "tcpdispatcher"

void TcpDispatcher::execute() {
    ostringstream o;
    o << clientfd();
    msg ("Dispatch request for client fd " + o.str() + "\n");

    try {
	dispatch();
    } catch (Error e) {
	cerr << e.txt() << "\n";
	close (clientfd());
	return;
    }

    ostringstream co;
    co << clientfd();
    ostringstream bo;
    bo << balancer.backend(target_backend).sock();
    msg ("Dispatching client fd " + co.str() + " to " +
	 balancer.backend(target_backend).description() +
	 ", fd " + bo.str() + "\n");
    
    lock();
    balancer.backend(target_backend).startconnection();
    unlock();

    try {
	handle();
    } catch (Error e) {
	cerr << e.txt() << "\n";
    }

    lock();
    balancer.backend(target_backend).endconnection();
    unlock();
    
    close (clientfd());
    close (backendfd());
    msg ("Done dispatching client fd " + co.str() + " at " +
	 balancer.backend(target_backend).description() + "\n");
	
}
