#include "tcpdispatcher"

TcpDispatcher::TcpDispatcher(int cfd, string cip):
    Thread(), client_ip(cip), target_backend(-1), client_fd(cfd),
    backend_fd(-1), data_bufsz(0) {

    // Set up a data buffer for network transfers
    data_buf = new char[config.buffersize()];

    // Instantiate dispatchmode algorithm
    switch (config.dispatchmode()) {
    case Dispatchmode::m_roundrobin:
	algorithm = new Roundrobin;
	break;
    case Dispatchmode::m_leastconn:
	algorithm = new Leastconn;
	break;
    case Dispatchmode::m_firstactive:
	algorithm = new Firstactive;
	break;
    case Dispatchmode::m_external:
	algorithm = new External;
	break;
    }
}
