#include "tcpdispatcher"

unsigned TcpDispatcher::writechunk (int dst, char const *b, unsigned blen) {
    // Client fd 0 (stdin) gets written to stdout.
    if (!dst)
	dst = 1;
    
    unsigned totwritten = 0;
    while (totwritten < blen) {
	ssize_t nwritten = write (dst, (void*) (b + totwritten),
				  blen - totwritten);
	if (nwritten < 1)
	    throw ((Error) "Write failed");
	
	if (config.debug()) {
	    ostringstream o;
	    o << "Sent " << nwritten << " bytes to fd " << dst << ": ";
	    for (unsigned i = 0; i < (unsigned) nwritten; i++)
		o << printable(b[totwritten + i]);
	    o << "\n";
	    debugmsg (o.str());
	}
	
	totwritten += nwritten;
    }
    return (totwritten);
}
